package gov.lbl.nest.lazarus.process;

import java.util.ArrayList;
import java.util.List;

import gov.lbl.nest.common.suspension.Suspendable;
import gov.lbl.nest.common.tasks.InspectorFactory;
import gov.lbl.nest.common.tasks.Supplier;
import gov.lbl.nest.lazarus.control.BodyCompletion;
import gov.lbl.nest.lazarus.control.ControlFlow;
import gov.lbl.nest.lazarus.control.ControlFlowException;
import gov.lbl.nest.lazarus.control.ControlOnlyActivityBody;
import gov.lbl.nest.lazarus.control.ControlOnlyActivityImpl;
import gov.lbl.nest.lazarus.control.FlowNodeInspectorFactory;
import gov.lbl.nest.lazarus.control.FlowNodeInspectorImpl;
import gov.lbl.nest.lazarus.data.DataCell;
import gov.lbl.nest.lazarus.data.DataFlowException;
import gov.lbl.nest.lazarus.data.DataOnlyActivityImpl;
import gov.lbl.nest.lazarus.data.FlowNodeTaskImpl;
import gov.lbl.nest.lazarus.data.MultiInstanceDataCell;
import gov.lbl.nest.lazarus.data.MultiInstanceLoopCharacteristicsImpl;
import gov.lbl.nest.lazarus.structure.DataObjectException;
import gov.lbl.nest.lazarus.structure.FlowNodeInspector;
import gov.lbl.nest.lazarus.structure.FlowNodeTask;

/**
 * This class implements the {@link ControlOnlyActivityBody} interface in order
 * to run multiple instances of an {@link DataOnlyActivityImpl} implementation.
 *
 * @author patton
 */
public class MultiInstanceBody extends
                               ActivityBody {

    /**
     * THis class is used to keep track of the completion of the branches created by
     * this object.
     *
     * @author patton
     */
    static class BranchExecutions {

        /**
         * The list of branch indices that have to be completed.
         */
        final List<Integer> branchesToExecute;

        /**
         * The {@link ControlOnlyActivityImpl} instance to call back to once all
         * branches have been completed.
         */
        final BodyCompletion callback;

        /**
         * The {@link ControlFlow} instance in which to execute the branches.
         */
        final ControlFlow control;

        /**
         * Sequence of {@link Throwable} instances thrown by the branches.
         */
        private List<Throwable> failures = new ArrayList<>();

        /**
         * Creates an instance of this class.
         *
         * @param control
         *            the {@link ControlFlow} instance in which to execute the branches.
         * @param callback
         *            the {@link ControlOnlyActivityImpl} instance to call back to once
         *            all branches have been completed.
         * @param size
         *            the number of branches created by this object.
         */
        BranchExecutions(ControlFlow control,
                         BodyCompletion callback,
                         int size) {
            final List<Integer> recoveredBranches = control.getRecoveredBranches();
            if (null == recoveredBranches) {
                branchesToExecute = new ArrayList<>();
                for (int index = 0;
                     size != index;
                     ++index) {
                    branchesToExecute.add(index);
                }
                control.setBranchesToRecover(branchesToExecute);
            } else {
                branchesToExecute = recoveredBranches;
            }
            this.callback = callback;
            this.control = control;
        }

        void completed(int branch) {
            final boolean complete;
            synchronized (branchesToExecute) {
                branchesToExecute.remove(Integer.valueOf(branch));
                control.setBranchesToRecover(branchesToExecute);
                complete = branchesToExecute.isEmpty();
            }
            if (complete) {
                callback.bodyExecutionCompleted(control);
            }
        }

        List<Integer> getBranchesToExecute(int size) {
            return branchesToExecute;
        }

        /**
         * Handles a {@link Throwable} instance generated by a branch.
         *
         * @param throwable
         *            the {@link Throwable} instance generated by a branch.
         */
        void handleThrowable(Throwable throwable) {
            final boolean first;
            synchronized (failures) {
                failures.add(throwable);
                first = (1 == failures.size());
            }
            if (first) {
                control.handleThrowable(throwable);
                throwable.printStackTrace();
            } else {
                control.captureThrowable(throwable);
            }
        }
    }

    /**
     * This class executes the responsibilities of a branch of this object.
     *
     * @author patton
     */
    static class MultiInstanceTask extends
                                   FlowNodeTaskImpl {

        /**
         * The {@link BranchExecutions} instance managing this execution.
         */
        private final BranchExecutions branchExecutions;

        /**
         * Creates an instance of this class.
         *
         * @param activity
         *            the {@link DataOnlyActivityImpl} instance within which this object
         *            is executing.
         * @param cell
         *            the {@link MultiInstanceDataCell} instance within which this
         *            object is executing.
         * @param rank
         *            the "rank" of this element, where object with a higher rank are
         *            preferred.
         * @param factory
         *            the {@link InspectorFactory} used to create new
         *            {@link FlowNodeInspectorImpl} instances.
         * @param suspendable
         *            the {@link Suspendable} instance used by this object to know
         *            whether it is active or not.
         * @param priority
         *            the "priority" of this element, where object with are higher
         *            priority a preferred.
         * @param branchExecutions
         *            the {@link BranchExecutions} instance managing this execution.
         */
        MultiInstanceTask(DataOnlyActivityImpl activity,
                          MultiInstanceDataCell cell,
                          Integer rank,
                          InspectorFactory<FlowNodeInspector> factory,
                          Suspendable suspendable,
                          Integer priority,
                          BranchExecutions branchExecutions) {
            super(activity,
                  cell,
                  factory,
                  suspendable,
                  rank,
                  priority);
            this.branchExecutions = branchExecutions;
        }

        @Override
        public void run() {
            try {
                execute();
                branchExecutions.completed(((MultiInstanceDataCell) getCell()).getIndex());
            } catch (Throwable e) {
                branchExecutions.handleThrowable(e.getCause());
            }
        }
    }

    /**
     * The {@link MultiInstanceLoopCharacteristicsImpl} instance characterizing the
     * behaviour of this object.
     */
    private final MultiInstanceLoopCharacteristicsImpl characteristics;

    /**
     * Creates an instance of this class
     *
     * @param flowNode
     *            the name of the {@link ActivityImpl} instance in this this object
     *            is executing.
     * @param characteristics
     *            the {@link MultiInstanceLoopCharacteristicsImpl} instance
     *            characterizing the behaviour of this object. collection.
     * @param taskRunner
     *            the {@link Supplier} instance that with run the
     *            {@link FlowNodeTask} instances created by this object.
     * @param suspendable
     *            the {@link Suspendable} instance used by this object to know
     *            whether it is active or not.
     */
    MultiInstanceBody(String flowNode,
                      MultiInstanceLoopCharacteristicsImpl characteristics,
                      Supplier<FlowNodeTask> taskRunner,
                      Suspendable suspendable) {
        super(flowNode,
              taskRunner,
              suspendable);
        this.characteristics = characteristics;
    }

    @Override
    public void execute(ControlFlow control,
                        BodyCompletion callback) {
        final DataOnlyActivityImpl activity = getDataOnlyActivityImpl();
        final DataCell cell;
        try {
            cell = ((ControlledDataFlow) control).createDataCell(activity);
        } catch (DataObjectException e) {
            throw new ControlFlowException(e);
        }

        final int size = characteristics.size(cell);

        final BranchExecutions branchExecutions = new BranchExecutions(control,
                                                                       callback,
                                                                       size);
        /**
         * As a branch can complete itself while this loop is still executing, the
         * following loop needs to be done over a copy of the branches collection so
         * that the original can be manipulated without causing a concurrency issue.
         */
        final List<Integer> branchesToExecute = new ArrayList<>(branchExecutions.getBranchesToExecute(size));
        if (branchesToExecute.isEmpty()) {
            callback.bodyExecutionCompleted(control);
            return;
        }

        final String label = (control.getControlScope()).getLabel();
        try {
            for (Integer index : branchesToExecute) {
                final MultiInstanceDataCell multiInstance = new MultiInstanceDataCell(characteristics,
                                                                                      cell,
                                                                                      index);
                final MultiInstanceTask task = new MultiInstanceTask(getDataOnlyActivityImpl(),
                                                                     multiInstance,
                                                                     getRank(),
                                                                     new FlowNodeInspectorFactory(label,
                                                                                                  getFlowNodeExecutions()),
                                                                     getSuspendable(),
                                                                     control.getPriority(),
                                                                     branchExecutions);
                final Supplier<FlowNodeTask> taskRunner = getTaskRunner();
                if (null == taskRunner) {
                    task.run();
                } else {
                    taskRunner.add(task);
                }
            }
        } catch (DataFlowException e) {
            throw new ControlFlowException(e);
        }
    }
}
